在做题中学习(49):排序数组中查找元素的第一个和最后一个位置

34. 在排序数组中查找元素的第一个和最后一个位置 - 力扣(LeetCode)

题目要求:时间复杂度为:O(logN),而且是有序数组,那一定就是二分法解决了

解法:二分查找

1.左端点

要找一个元素的第一次出现的位置的情况,我们可以把数组分为两个区间,如下:

因为如果mid 落在 <3的区间,可以直接让left = mid + 1,因为答案绝对不可能在 <3 的区间里。

1. mid < target left = mid + 1;

因为如果mid 落在 >=3的区间,就不可以让 right = mid - 1,因为此区间是 >= 3的,所以有可能mid就在此区间第一个 == 3的位置,如果更新right 为 mid - 1,那么就会跑到<3的区间,永远都找不到值。

2.mid >= target right = mid;

3.循环结束条件 while(left < right) 因为上面的逻辑 最后会走到 left == right 才会有最终答案

2.右端点

要找一个元素的最后一次出现的位置的情况,我们可以把数组分为两个区间,如下:

因为如果mid 落在 >3的区间,可以直接让right = mid - 1,因为答案绝对不可能在 >3 的区间里。

1. mid > target right = mid - 1;

因为如果mid 落在 <=3的区间,就不可以让 left = mid + 1,因为此区间是 <= 3的,所以有可能mid就在此区间最后一个 == 3的位置,如果更新left 为 mid + 1,那么就会跑到>3的区间,永远都找不到值。

2.mid <= target left = mid;

3.循环结束条件 while(left < right) 因为上面的逻辑 最后会走到 left == right 才会有最终答案

细节问题

1.数组中没有target的情况

直接先在开始判断 :如果 数组元素为0,返回 {-1,-1}

判断左端点的时候 最后left == right ,只需循环结束后,判断一下 != target 返回{-1,-1}即可.

2.不动问题

求左端点, 如果用右边的 +1 公式求mid,那么最后剩两个元素的时候,如果命中 mid >= target的条件上,那么right不会动,程序陷入死循环, 所以要用不+1的公式。

求右端点, 如果用左边 不+1 公式求mid,那么最后剩两个元素的时候,如果命中 mid <= target的条件上,那么left不会动,程序陷入死循环, 所以要用+1的公式。

cpp 复制代码
class Solution {
public:
    vector<int> searchRange(vector<int>& nums, int target) 
    {
        if(nums.size() == 0)
            return {-1,-1};
        vector<int> ret;
        int mid = 0;
        //1.寻找区间左端点
        int left = 0,right = nums.size()-1;
        while(left<right)
        {
            mid = left + (right - left) /2;
            if(nums[mid] < target) 
                left = mid + 1;
            else if(nums[mid] >= target)
                right = mid;
        }
        //走到这,left = right,找到左端点,但还需判断是不是 == target
        if(nums[left] != target)
            return {-1,-1};
        else
            ret.push_back(left);
        //2.寻找区间右端点
        left = 0,right = nums.size()-1;
        while(left<right)
        {
            mid = left + (right - left + 1) /2;
            if(nums[mid] <= target)
                left = mid;
            else if(nums[mid] > target)
                right = mid - 1;
        }
        //走到这,left = right,找到右端点
        ret.push_back(left);
        return ret;
    }
};
相关推荐
一去不复返的通信er1 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
行思理2 小时前
go语言学习难度及适合学习的人群
开发语言·学习·golang
青瓦梦滋2 小时前
WebSocket协议
linux·服务器·网络·c++·websocket·网络协议·http
程序 代码狂人4 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade5 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
楚山之石6 小时前
【Medical Image Analysis】深度学习医学图像合成综述:伪CT、合成MRI与合成PET的架构、性能与临床边界
图像处理·人工智能·学习·mr·mri
Li_RuiQi6 小时前
DAgger方法演进_独立学习笔记
笔记·学习·计算机视觉
小郎君6587 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
CodeYp20197 小时前
第15讲:二叉搜索树
开发语言·c++·二叉搜索树
邵奈一7 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法